#pragma once

#include "sprite.h"
#include "utils.h"

#ifndef TEXT_H
#define TEXT_H

#define TXT_COLOR 1
#define TXT_SHADOW 2
#define TXT_CENTER 4
#define TXT_STROKE 8

struct offset_t
{
	int x;
	int y;
	int w;
};

struct textFile_t
{
	int boxWidth;		  // Anchura de la caja de cada caracter en el png
	int boxHeight;		  // Altura de la caja de cada caracter en el png
	offset_t offset[128]; // Vector con las posiciones y ancho de cada letra
};

// Llena una estructuta textFile_t desde un fichero
textFile_t LoadTextFile(string file, bool verbose = false);

// Clase texto. Pinta texto en pantalla a partir de un bitmap
class Text
{
private:
	// Objetos y punteros
	Texture *texture; // Textura con los gráficos para el texto
	Sprite *sprite;	  // Objeto para dibujar el texto

	// Variables
	int zoom;			  // Tamaño del texto
	int boxWidth;		  // Anchura de la caja de cada caracter en el png
	int boxHeight;		  // Altura de la caja de cada caracter en el png
	bool fixedWidth;	  // Indica si el texto se ha de escribir con longitud fija en todas las letras
	offset_t offset[128]; // Vector con las posiciones y ancho de cada letra

public:
	// Constructor
	Text(string textFile, string bitmapFile, SDL_Renderer *renderer);
	Text(string textFile, Texture *texture, SDL_Renderer *renderer);
	Text(textFile_t *textFile, Texture *texture, SDL_Renderer *renderer);

	// Destructor
	~Text();

	// Escribe el texto en pantalla
	void write(int x, int y, string text, int kerning = 1, int lenght = -1);

	// Escribe el texto con colores
	void writeColored(int x, int y, string text, color_t color, int kerning = 1, int lenght = -1);

	// Escribe el texto con sombra
	void writeShadowed(int x, int y, string text, color_t color, Uint8 shadowDistance = 1, int kerning = 1, int lenght = -1);

	// Escribe el texto centrado en un punto x
	void writeCentered(int x, int y, string text, int kerning = 1, int lenght = -1);

	// Escribe texto con extras
	void writeDX(Uint8 flags, int x, int y, string text, int kerning = 1, color_t textColor = {255, 255, 255}, Uint8 shadowDistance = 1, color_t shadowColor = {0, 0, 0}, int lenght = -1);

	// Obtiene la longitud en pixels de una cadena
	int lenght(string text, int kerning = 1);

	// Devuelve el valor de la variable
	int getCharacterSize();

	// Recarga la textura
	void reLoadTexture();

	// Establece si se usa un tamaño fijo de letra
	void setFixedWidth(bool value);

	// Establece el tamaño del zoom
	void setZoom(int value);

	// Quita el zoom
	void disableZoom();
};

#endif
